<template>
  <div class="d-flex mt-2 mx-4 caption align-center">
    <v-text-field
      style="max-width:28%;"
      dense
      clearable
      v-model="search"
      v-if="props.searchEnabled"
      :label="searchLabel"
      append-icon="mdi-magnify"
    >
    </v-text-field>
    <v-select
      v-if="tags && tags.length"
      dense
      :label="`Filter by ${tagType === 'contact' ? 'Contact' : 'Orga'}-Tag`"
      :class="props.searchEnabled ? 'ml-4' : ''"
      :style="props.searchEnabled ? 'max-width: 22%;' : 'max-width: 28%;'"
      :items="tags"
      @change="tagChanged"
      v-model="tagToFilterBy"
      return-object
      clearable
      item-text="name"
    ></v-select>
    <v-switch v-if="type === 'contact'" v-model="expiredOnly" color="warning" class="ml-4" label="Expired only"></v-switch>
    <v-select
      v-if="props.type === 'users' && !$store.getters['user/isOrgaAdmin']"
      dense
      label="Filter by portal role"
      :style="props.searchEnabled ? 'max-width: 22%;' : 'max-width: 28%;'"
      :class="props.searchEnabled ? 'ml-4' : ''"
      :items="portalRoles"
      v-model="portalRoleToFilterBy"
      clearable
      item-text="name"
      item-value="value"
      >
    </v-select>
    <div class="ml-auto">
      <span>Items per page</span>
      <v-menu offset-y>
        <template v-slot:activator="{ on, attrs }">
          <v-btn text small class="px-0 caption" v-bind="attrs" v-on="on">
            {{ itemsPerPage }}
            <v-icon>mdi-chevron-down</v-icon>
          </v-btn>
        </template>
        <v-list>
          <v-list-item
            v-for="(number, index) in itemsPerPageArray"
            :key="index"
            @click="updateItemsPerPage(number)"
          >
            <v-list-item-title>{{ number }}</v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
      <span class="mr-1"> Page {{ page }} of {{ numberOfPages }} </span>
      <v-icon :disabled="page === 1" @click="formerPage()"
        >mdi-chevron-left</v-icon
      >
      <v-icon :disabled="page === numberOfPages" @click="nextPage()"
        >mdi-chevron-right</v-icon
      >
    </div>
  </div>
</template>

<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * 2021, 2022 Fadi Abbud <fadi.abbud@intevation.de>
 */
import { computed, ref, watch } from "vue";
import debounce from "debounce";

interface Props {
  totalItems?: number;
  sortDirection?: string;
  searchEnabled?: boolean;
  tags?: object[];
  type?: string;
}
interface Option {
  page?: number;
  itemsPerPage?: number;
  search?: string;
  sortForRequest?: string;
  tagToFilterBy?: string;
  roleToFilterBy?: string;
  expiredOnly?: boolean;
}

const props = defineProps<Props>();
const emit = defineEmits(["pagination-object"]);

const tagType = computed(() => {
  if (props.tags && props.tags.length) {
    if (props.tags.some(t => t["contact_tag_id"])) {
      return "contact";
    }
    if (props.tags.some(t => t["organisation_tag_id"])) {
      return "organisation";
    }
  }
  return "";
});
const searchLabel = computed(() => {
  const text = "Search for";

  if (props.type === "netobject") {
    return text + " Netobject(s)";
  }

  if (props.type === "contact") {
    return text + " Contact(s)";
  }

  if (props.type === "organisation") {
    return text + " Organisation(s)";
  }

  return text + " User(s)";
});
const tagToFilterBy = ref();
const portalRoleToFilterBy = ref();
const tagChanged = () => {
  page.value = 1;
  emit("pagination-object", {
    refresh: true,
    options: buildOptions()
  });
};

const expiredOnly = ref(false);

const itemsPerPageArray = ref([3, 5, 10, 15]);
const page = ref(1);
const itemsPerPage = ref(10);
const numberOfPages = computed(() => {
  return Math.ceil(props.totalItems / itemsPerPage.value);
});
const updateItemsPerPage = n => {
  itemsPerPage.value = n;
  page.value = 1;
};
const nextPage = () => {
  if (page.value + 1 <= numberOfPages.value) {
    page.value++;
  }
};
const formerPage = () => {
  if (page.value - 1 >= 1) page.value--;
};
watch([() => itemsPerPage.value, () => page.value], () => {
  emit("pagination-object", {
    refresh: true,
    options: buildOptions()
  });
});

const buildOptions = () => {
  const options: Option = {} as Option;

  options.page = page.value;
  options.itemsPerPage = itemsPerPage.value;
  options.search = search.value;
  options.expiredOnly = expiredOnly.value;
  options.portalRoleToFilterBy = portalRoleToFilterBy.value;
  options.sortForRequest = sortForRequest.value;

  if (tagToFilterBy.value) {
    options.tagToFilterBy =
      tagToFilterBy.value.organisation_tag_id ||
      tagToFilterBy.value.contact_tag_id;
  }
  return options;
};
const search = ref("");
const triggerSearch = debounce(() => {
  emit("pagination-object", {
    refresh: true,
    options: buildOptions()
  });
}, 500);
watch(
  () => search.value,
  (newValue, oldValue) => {
    if (oldValue !== newValue) {
      page.value = 1;
      triggerSearch(newValue);
    }
  }
);
const sortForRequest = ref();
watch(
  () => props.sortDirection,
  () => {
    if (props.sortDirection && props.sortDirection[0]) {
      sortForRequest.value = "asc";
      emit("pagination-object", {
        refresh: true,
        options: buildOptions()
      });
    } else {
      sortForRequest.value = "desc";
      emit("pagination-object", {
        refresh: true,
        options: buildOptions()
      });
    }
  }
);

watch(() => expiredOnly.value,
    () => {
      emit("pagination-object", {
        refresh: true,
        options: buildOptions()
      });
    }
);

watch(() => portalRoleToFilterBy.value, () => {
  emit("pagination-object", {
    refresh: true,
    options: buildOptions()
  });
});

const portalRoles = [
  {
    name: "Portal-Admin",
    icon: "mdi-alpha-p-box-outline",
    value: "portaladmin"
  },
  {
    name: "Tenant-Admin",
    icon: "mdi-alpha-t-box-outline",
    value: "tenantadmin"
  },
  {
    name: "Organisation-Admin",
    icon: "mdi-alpha-o-box-outline",
    value: "orgaadmin"
  }
];
</script>
